From: =?utf-8?q?Bastien_Roucari=C3=A8s?= <rouca@debian.org>
Date: Mon, 30 Oct 2023 13:39:57 +0000
Subject: bpo-38275: skip ssl test

Backport skip ssl test to test at build time disabled ssl protocol
---
 Lib/test/test_ssl.py | 97 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 97 insertions(+)

diff --git a/Lib/test/test_ssl.py b/Lib/test/test_ssl.py
index 7049f4d..f84a6b3 100644
--- a/Lib/test/test_ssl.py
+++ b/Lib/test/test_ssl.py
@@ -75,6 +75,99 @@ DHFILE = data_file("ffdh3072.pem")
 BYTES_DHFILE = os.fsencode(DHFILE)
 
 
+
+
+__PROTO_TAG = "PROTOCOL_"
+__OP_NO_TAG = "OP_NO_"
+__OP_NO_TAG_LEN = len(__OP_NO_TAG)
+_PROTOS_DATA = list()
+for item_name in dir(ssl):
+    if item_name.startswith(__OP_NO_TAG) and item_name[-1].isdigit():  # item_name[-1].isdigit() condition is required because protocol denial (OP_NO_*) constants end in digit(s) (version); therefore constants like OP_NO_TICKET are excluded
+        op_no_item = getattr(ssl, item_name)
+        if op_no_item:
+            proto_name = item_name[__OP_NO_TAG_LEN:]
+            _PROTOS_DATA.append((proto_name, getattr(ssl, __PROTO_TAG + proto_name, -1), op_no_item))
+del __OP_NO_TAG_LEN
+del __OP_NO_TAG
+del __PROTO_TAG
+
+
+def get_protocols(ctx):
+    supported_classes = (ssl.SSLContext,)
+    if not isinstance(ctx, supported_classes):
+        raise TypeError("Argument must be an instance of `{:}`".format(supported_classes[0] if len(supported_classes) == 1 else supported_classes))
+    protocols = list()
+    for proto_data in _PROTOS_DATA:
+        if ctx.options & proto_data[-1] != proto_data[-1]:
+            protocols.append(proto_data[:-1])
+    return protocols
+
+
+def has_version(version):
+    ctx = ssl.create_default_context()
+    for proto in get_protocols(ctx):
+        if proto[0] == version:
+            if proto[1] != -1:
+                return True
+    return False
+
+def has_tls_version(version):
+    """Check if a TLS/SSL version is enabled
+
+    :param version: TLS version name or ssl.TLSVersion member
+    :return: bool
+    """
+    if version == "SSLv2":
+        # never supported and not even in TLSVersion enum
+        return False
+
+    return has_version(version)
+
+def has_tls_protocol(protocol):
+    """Check if a TLS protocol is available and enabled
+
+    :param protocol: enum ssl._SSLMethod member or name
+    :return: bool
+    """
+    if isinstance(protocol, str):
+        assert protocol.startswith('PROTOCOL_')
+        protocol = getattr(ssl, protocol, None)
+        if protocol is None:
+            return False
+    if protocol in {
+        ssl.PROTOCOL_TLS, ssl.PROTOCOL_TLS_SERVER,
+        ssl.PROTOCOL_TLS_CLIENT
+    }:
+        # auto-negotiate protocols are always available
+        return True
+    name = protocol.name
+    return has_tls_version(name[len('PROTOCOL_'):])
+
+
+def requires_tls_version(version):
+    """Decorator to skip tests when a required TLS version is not available
+
+    :param version: TLS version name or ssl.TLSVersion member
+    :return:
+    """
+    def decorator(func):
+        @functools.wraps(func)
+        def wrapper(*args, **kw):
+            if not has_tls_version(version):
+                raise unittest.SkipTest("{} is not available.".format(version))
+            else:
+                return func(*args, **kw)
+        return wrapper
+    return decorator
+
+
+
+requires_minimum_version = unittest.skipUnless(
+    hasattr(ssl.SSLContext, 'minimum_version'),
+    "required OpenSSL >= 1.1.0g"
+)
+
+
 def handle_error(prefix):
     exc_format = ' '.join(traceback.format_exception(*sys.exc_info()))
     if support.verbose:
@@ -132,6 +225,10 @@ needs_sni = unittest.skipUnless(ssl.HAS_SNI, "SNI support needed for this test")
 
 
 class BasicSocketTests(unittest.TestCase):
+    def test_print_supported_ssl(self):
+        ctx = ssl.create_default_context()
+        for proto in get_protocols(ctx):
+            sys.stdout.write(pprint.pformat(proto) + "\n")
 
     def test_constants(self):
         ssl.CERT_NONE
